-- Source code from
--   Purely Functional Data Structures
--   Chris Okasaki
--   Cambridge University Press, 1998
--
-- Copyright (c) 1998 Cambridge University Press

module Deque (Deque(..)) where
import Prelude hiding (head,tail,last,init)

class Deque q where
  empty   :: q a
  isEmpty :: q a -> Bool

  cons    :: a -> q a -> q a
  head    :: q a -> a
  tail    :: q a -> q a

  snoc    :: q a -> a -> q a
  last    :: q a -> a
  init    :: q a -> q a
