{-# LANGUAGE
    FlexibleInstances
 #-}
import Prelude hiding ((++))

import BankersDeque (BankersDeque)
import Data.Monoid ((<>))
import SimpleCatenableDeque

instance Show a => Show (SimpleCatDeque BankersDeque a) where
  show val = case val of
      Shallow wrapped -> "(Shallow (" <> show wrapped <> "))"
      Deep left child right -> "(Deep " <>
        "(" <> show left <> ") " <>
        "(" <> show child <> ") " <>
        "(" <> show right <> "))"

hoopy :: SimpleCatDeque BankersDeque Int
hoopy = empty

hoh :: SimpleCatDeque BankersDeque Int
hoh = (5 `cons` hoopy) `snoc` 15

huao :: SimpleCatDeque BankersDeque Int
huao = hoh ++ hoh

main :: IO ()
main = do
    print hoh
    print huao
    return ()
